## mx-snapshot 23.10.01

=== debian/changelog ===
mx-snapshot (23.10.01) mx; urgency=medium

  * Exclude ~/.config/MX-Linux/xdg_check to make sure default Desktop files (installer link) are recreated

 -- Adrian <adrian@mxlinux.org>  Tue, 10 Oct 2023 12:49:43 -0400

## mx-snapshot 23.11

=== debian/changelog ===
mx-snapshot (23.11) mx; urgency=medium

  * Run program as normal user and elevate only when needed
  * Prioritize user settings over system settings. Settings available in ~/.conf/MX-Linux/ directory
  * Added -processors and -throttle options in the GUI and CLI arguments, see --help for CLI args
        -- if you used to pass any of these options directly in .conf file might neet to remove those

 -- Adrian <adrian@mxlinux.org>  Sat, 11 Nov 2023 19:42:42 -0500

## mx-snapshot 23.11.01mx21

=== debian/changelog ===
mx-snapshot (23.11.01mx21) mx; urgency=medium

  * Fix for Bullseys distro, remove -throttle option (not available in older mksquasfs)

 -- Adrian <adrian@mxlinux.org>  Sun, 12 Nov 2023 21:21:29 -0500

## mx-snapshot 23.11.02

=== debian/changelog ===
mx-snapshot (23.11.02) mx; urgency=medium

  * Unified builds for MX21 and MX23

 -- Adrian <adrian@mxlinux.org>  Wed, 15 Nov 2023 16:59:48 -0500

mx-snapshot (23.11.01) mx; urgency=medium

  * Fix: use /home/user instead of /home for temp directory (this solves a permission issue)

 -- Adrian <adrian@mxlinux.org>  Wed, 15 Nov 2023 16:14:41 -0500

## mx-snapshot 23.11.03

=== debian/changelog ===
mx-snapshot (23.11.03) mx; urgency=medium

  * Fix: getting xdg-user-dir info

 -- Adrian <adrian@mxlinux.org>  Fri, 17 Nov 2023 02:50:01 -0500

## mx-snapshot 23.11.05

=== debian/changelog ===
mx-snapshot (23.11.05) mx; urgency=medium

  * Fix: more quoting to allow for spaces in snapshot directory

 -- Adrian <adrian@mxlinux.org>  Tue, 28 Nov 2023 00:20:42 -0500

mx-snapshot (23.11.04) mx; urgency=medium

  * Fix: spaces in snapshot and working directory
  * Fix: relative directory path in commandline arguments

 -- fehlix <fehlix@mxlinux.org>  Mon, 27 Nov 2023 20:03:18 -0500

## mx-snapshot 23.12.01

=== debian/changelog ===
mx-snapshot (23.12.01) mx; urgency=medium

  * Fix: quoting in sed replacement file path
  * Use entryFileInfolist instead of iterator to avoid I/O timing issues

 -- fehlix <fehlix@mxlinux.org>  Sat, 02 Dec 2023 20:09:10 -0500

## mx-snapshot 23.12.02

=== debian/changelog ===
mx-snapshot (23.12.02) mx; urgency=medium

  * Add minimum width for number of cores box

 -- Adrian <adrian@mxlinux.org>  Mon, 11 Dec 2023 23:00:41 -0500

## mx-snapshot 24.01.01

=== debian/changelog ===
mx-snapshot (24.01.01) mx; urgency=medium

  * Add device mapper modules to avoid Ventoy crashes

 -- fehlix <fehlix@mxlinux.org>  Sun, 28 Jan 2024 09:01:56 -0500

## mx-snapshot 24.02

=== debian/changelog ===
mx-snapshot (24.02) mx; urgency=medium

  * Edit config file for user instead of system

 -- Adrian <adrian@mxlinux.org>  Sat, 10 Feb 2024 21:21:20 -0500

## mx-snapshot 24.02.03

=== debian/changelog ===
mx-snapshot (24.02.03) mx; urgency=medium

  * Fix: write actual snapshot date/time creation to /etc/snapshot_created
  * Fix: edit exclusion button opens the correct file

 -- Adrian <adrian@mxlinux.org>  Mon, 12 Feb 2024 11:58:40 -0500

## mx-snapshot 24.02.04

=== debian/changelog ===
mx-snapshot (24.02.04) mx; urgency=medium

  * Faster exclusion checkbox selection
  * Fix: doesn't exclude files twice when selecting Exclude All
  * Slightly better calculation for the size of excluded files

 -- Adrian <adrian@mxlinux.org>  Wed, 14 Feb 2024 02:04:49 -0500

## mx-snapshot 24.3

=== debian/changelog ===
mx-snapshot (24.3) mx; urgency=medium

  * Fix: log creation

 -- Adrian <adrian@mxlinux.org>  Sun, 17 Mar 2024 10:04:19 -0400

## mx-snapshot 24.3.01

=== debian/changelog ===
mx-snapshot (24.3.01) mx; urgency=medium

  * Fix: for system that use different umask, set umask to 022 before running mksquashfs command

 -- Adrian <adrian@mxlinux.org>  Sun, 17 Mar 2024 14:10:36 -0400

## mx-snapshot 24.4

=== debian/changelog ===
mx-snapshot (24.4) mx; urgency=medium

  * Add system language, keyboard, timezon to boot parameter field
  * Adjust exclusion list: live and ~/.cache/xfce4/clipman
  * Change error message to direct user to log

 -- Adrian <adrian@mxlinux.org>  Thu, 11 Apr 2024 16:49:08 -0400

## mx-snapshot 24.4.01

=== debian/changelog ===
mx-snapshot (24.4.01) mx; urgency=medium

  * Update translations
  * Minor: for monthly snapshot use default kernel options

 -- Adrian <adrian@mxlinux.org>  Wed, 17 Apr 2024 19:24:18 -0400

## mx-snapshot 24.4.02

=== debian/changelog ===
mx-snapshot (24.4.02) mx; urgency=medium

  * Skip display of default keyboard options bootparameter (kbopt)

 -- fehlix <fehlix@mxlinux.org>  Thu, 18 Apr 2024 18:55:15 -0400

## mx-snapshot 24.5

=== debian/changelog ===
mx-snapshot (24.5) mx; urgency=medium

  * Run editor as user when editing exclusion file if the editor elevates
    itself; added codium, removed atom from the list of possible editors
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Fri, 24 May 2024 13:42:23 -0400

## mx-snapshot 24.6

=== debian/changelog ===
mx-snapshot (24.6) mx; urgency=medium

  * Check whether linuxfs was copied to the ram during the live boot

 -- fehlix <fehlix@mxlinux.org>  Wed, 05 Jun 2024 14:45:24 -0400

## mx-snapshot 24.7.02

=== debian/changelog ===
mx-snapshot (24.7.02) mx; urgency=medium

  * Fix: run nvidia check only once and only if it xorg=nvidia is not
    already added

 -- Adrian <adrian@mxlinux.org>  Wed, 24 Jul 2024 13:35:06 -0400

mx-snapshot (24.7.01) mx; urgency=medium

  * Add prompt when detecting nvidia and add xorg=nvidia to kernel
    options if the user plans to use the ISO on the same/similar
    computer

 -- Adrian <adrian@mxlinux.org>  Wed, 24 Jul 2024 07:33:17 -0400

## mx-snapshot 24.7.03

=== debian/changelog ===
mx-snapshot (24.7.03) mx; urgency=medium

  * Remove the nvidia boot option that may have been added with a
    previous snapshot

 -- fehlix <fehlix@mxlinux.org>  Wed, 24 Jul 2024 13:35:06 -0400

## mx-snapshot 24.8

=== debian/changelog ===
mx-snapshot (24.8) mx; urgency=medium

  * Add support for ext2 and zfs for temporary work directory
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Mon, 05 Aug 2024 12:02:33 -0400

## mx-snapshot 24.8.01

=== debian/changelog ===
mx-snapshot (24.8.01) mx; urgency=medium

  * Use QCalendarWidget to select release date and combobox to select
    the kernel

 -- Adrian <adrian@mxlinux.org>  Wed, 14 Aug 2024 22:23:48 -0400

## mx-snapshot 24.8.02

=== debian/changelog ===
mx-snapshot (24.8.02) mx; urgency=medium

  * Fix terminal output for progress bar and pulsing "Progress ..."
  * Minor: replaced use of "column" with printf to avoid bsdextrautils
    dependency

 -- Adrian <adrian@mxlinux.org>  Thu, 15 Aug 2024 19:12:42 -0400

## mx-snapshot 24.9.01

=== debian/changelog ===
mx-snapshot (24.9.01) mx; urgency=medium

  * Add exclude Flatpak option
  * Fix: ignore error when reading xdg-user-dir output

 -- Adrian <adrian@mxlinux.org>  Sun, 01 Sep 2024 22:12:04 -0400

## mx-snapshot 24.9.03

=== debian/changelog ===
mx-snapshot (24.9.03) mx; urgency=medium

  * Fix string quoting for excludeFlatpak

 -- Adrian <adrian@mxlinux.org>  Mon, 02 Sep 2024 18:49:57 -0400

## mx-snapshot 24.12

=== debian/changelog ===
mx-snapshot (24.12) mx; urgency=medium

  * Add /var/log/journal/* to exclusion list
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Sun, 22 Dec 2024 01:46:35 -0500

## mx-snapshot 24.12.01

=== debian/changelog ===
mx-snapshot (24.12.01) mx; urgency=medium

  * revert changes to copy-initrd helper programs

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Mon, 30 Dec 2024 19:01:15 -0500

## mx-snapshot 25.2

=== debian/changelog ===
mx-snapshot (25.2) mx; urgency=medium

  * Fix: allow some special characters in file names

 -- Adrian <adrian@mxlinux.org>  Sun, 02 Feb 2025 18:49:33 -0500

## mx-snapshot 25.4

=== debian/changelog ===
mx-snapshot (25.4) mx; urgency=medium

  * Adjust kmod and luks2 handling within copy-initrd-programs needed for trixie
  * Add cryptsetup into initrd
  * Make copy-initrd-programs shellcheck safe
  * Add Debian release code names Trixie, Forky, and Duke to enum in settings

 -- fehlix <fehlix@mxlinux.org>  Sun, 13 Apr 2025 17:31:38 -0400

=== debian/control ===
Source: mx-snapshot
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Homepage: https://mxlinux.org
Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/AdrianTM/mx-snapshot

Package: mx-snapshot
Architecture: any
Depends: mx-iso-template | iso-template (>= 16.1mx15),
         mx-remaster,
         squashfs-tools,
         syslinux-utils,
         xdg-user-dirs,
         xorriso (>= 1.4.6),
         ${misc:Depends},
         ${shlibs:Depends}
Description: MX Snapshot
 MX Snapshot is a tool used for creating a live-CD from the running system.

Package: iso-snapshot-cli
Architecture: any
Depends: mx-iso-template | iso-template (>= 16.1mx15),
         mx-remaster,
         squashfs-tools,
         syslinux-utils,
         xdg-user-dirs,
         xorriso (>= 1.4.6),
         ${misc:Depends},
         ${shlibs:Depends}
Description: ISO Snapshoti CLI
 ISO Snapshot CLI is a tool used for creating a live-CD from the running system.
 This tool is the CLI-exclusive version of MX Snapshot, if you need a GUI, use MX Snapshot

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5

DEB_BUILD_VERSION := $(shell dpkg-parsechangelog -S Version)

override_dh_auto_clean:
	dh_auto_clean
	rm -f manual/*.gz
	rm -f src/manual/*.gz
	rm -f translations/*.qm
	rm -f src/translations/*.qm

override_dh_auto_configure:
	dh_auto_configure -- mx-snapshot.pro

override_dh_auto_build:
	lrelease translations/*.ts
	mv version.h version.h~
	echo "const QString VERSION {\"$(DEB_BUILD_VERSION)\"};" > version.h
	gzip -kf manual/mx-snapshot.8
	gzip -kf manual/iso-snapshot-cli.8
	# build mx-snapshot
	dh_auto_build
	mv mx-snapshot mx-snapshot-binary
	# clean, reconfigure, and build iso-snapshot-cli
	mv version.h~ version.h
	dh_auto_clean
	mv version.h version.h~
	echo "const QString VERSION {\"$(DEB_BUILD_VERSION)\"};" > version.h
	dh_auto_configure -- iso-snapshot-cli.pro
	dh_auto_build
	# before installing move binary back and make a iso-snapshot-cli copy of .list file
	mv mx-snapshot-binary mx-snapshot
	cp mx-snapshot-exclude.list iso-snapshot-cli-exclude.list

override_dh_shlibdeps:
	dh_shlibdeps -- -xvirtualbox-guest-x11 --ignore-missing-info

execute_after_dh_builddeb:
	mv version.h~ version.h

%:
	dh $@ --no-automatic-dbgsym --parallel

## mx-snapshot 25.6.01

=== debian/changelog ===
mx-snapshot (25.6.01) mx; urgency=medium

  * Fix: create directory before trying to link the file

 -- Adrian <adrian@mxlinux.org>  Fri, 06 Jun 2025 23:36:31 -0400

mx-snapshot (25.6) mx; urgency=medium

  * Prepare to move stuff out of /usr/local/; Read script from alternative location

 -- Adrian <adrian@mxlinux.org>  Fri, 06 Jun 2025 20:40:07 -0400

mx-snapshot (25.4.01) mx; urgency=medium

  * Update to Qt6

 -- Adrian <adrian@mxlinux.org>  Thu, 24 Apr 2025 19:05:07 -0400

=== debian/control ===
Source: mx-snapshot
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (= 13),
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/MX-Linux/mx-snapshot
Homepage: https://github.com/MX-Linux/mx-snapshot

Package: mx-snapshot
Architecture: any
Depends: mx-iso-template | iso-template (>= 16.1mx15),
         mx-remaster,
         mx-viewer | xdg-utils,
         squashfs-tools,
         syslinux-utils,
         xdg-user-dirs,
         xorriso (>= 1.4.6),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: mx-launcher-l10n
Description: System snapshot tool for MX Linux
 MX Snapshot is a graphical utility that allows users to create a live-CD/USB
 image from their running MX Linux system. It provides a user-friendly interface
 for:
  * Creating bootable system backups
  * Preserving user data and settings
  * Generating distributable ISO images

Package: iso-snapshot-cli
Architecture: any
Depends: mx-iso-template | iso-template (>= 16.1mx15),
         mx-remaster,
         squashfs-tools,
         syslinux-utils,
         xdg-user-dirs,
         xorriso (>= 1.4.6),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Command-line system snapshot tool for MX Linux
 ISO Snapshot CLI is a command-line utility that allows users to create a
 live-CD/USB image from their running MX Linux system. It provides the same
 core functionality as MX Snapshot without requiring a graphical interface.
 For users who prefer a graphical interface, please use the mx-snapshot package.

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake6 QMAKE_OPTS="$(QMAKE_OPTS)"
DEB_BUILD_VERSION := $(shell dpkg-parsechangelog -S Version)

override_dh_auto_clean:
	dh_auto_clean
	-find manual src/manual -name '*.gz' -delete || true
	-find translations src/translations -name '*.qm' -delete || true

override_dh_auto_configure:
	qmake6 mx-snapshot.pro

override_dh_auto_build:
	/usr/lib/qt6/bin/lrelease translations/*.ts
	@# Backup version.h if it exists
	[ -f version.h ] && mv version.h version.h~ || true
	echo "const QString VERSION {\"$(DEB_BUILD_VERSION)\"};" > version.h
	gzip -kf manual/mx-snapshot.8 manual/iso-snapshot-cli.8
	# Build mx-snapshot
	dh_auto_build
	mv mx-snapshot mx-snapshot-binary
	# Clean, reconfigure, and build iso-snapshot-cli
	[ -f version.h~ ] && mv version.h~ version.h || true
	dh_auto_clean
	[ -f version.h ] && mv version.h version.h~ || true
	echo "const QString VERSION {\"$(DEB_BUILD_VERSION)\"};" > version.h
	rm -f mx-snapshot.pro Makefile
	qmake6 iso-snapshot-cli.pro
	dh_auto_build
	# Before installing, move binary back and make a iso-snapshot-cli copy of .list file
	mv mx-snapshot-binary mx-snapshot
	cp -f mx-snapshot-exclude.list iso-snapshot-cli-exclude.list
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

execute_after_dh_builddeb:
	[ -f version.h~ ] && mv version.h~ version.h || true

%:
	dh $@ --no-automatic-dbgsym

## mx-snapshot 25.09

=== debian/changelog ===
mx-snapshot (25.09) mx; urgency=medium

  * Fix log ownership
  * Run in CLI automatically if windowing system is not detected
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Tue, 09 Sep 2025 19:26:48 -0400

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper-compat (= 13),
-               qt6-base-dev,
-               qt6-base-dev-tools,
-               qt6-tools-dev,
-               qt6-tools-dev-tools
+Build-Depends: debhelper-compat (=12), cmake (>= 3.16), ninja-build, qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools
 Standards-Version: 3.9.8
 Vcs-Git: git://github.com/MX-Linux/mx-snapshot
 Homepage: https://github.com/MX-Linux/mx-snapshot

## mx-snapshot 25.09.2

=== debian/changelog ===
mx-snapshot (25.09.2) mx; urgency=medium

  * Use sudo for elevation in CLI mode; fix cleanup issue when
    pkexec/gksu are not present

 -- Adrian <adrian@mxlinux.org>  Wed, 10 Sep 2025 00:34:55 -0400

## mx-snapshot 25.10

=== debian/changelog ===
mx-snapshot (25.10) mx; urgency=medium

  * Trim quotes when reading options
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Wed, 01 Oct 2025 12:59:15 -0400

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
          syslinux-utils,
          xdg-user-dirs,
          xorriso (>= 1.4.6),
+         sudo | pkexec | gksu,
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: mx-launcher-l10n
@@ -35,6 +36,7 @@
          syslinux-utils,
          xdg-user-dirs,
          xorriso (>= 1.4.6),
+         sudo | pkexec | gksu,
          ${misc:Depends},
          ${shlibs:Depends}
 Description: Command-line system snapshot tool for MX Linux

## mx-snapshot 25.10.1

=== debian/changelog ===
mx-snapshot (25.10.1) mx; urgency=medium

  * Fix: edit_boot_menu now honors the system setting by falling back to
    /etc/mx-snapshot.conf when the user config lacks the key

 -- Adrian <adrian@mxlinux.org>  Mon, 27 Oct 2025 09:02:04 -0400

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

override_dh_auto_configure:
	dh_auto_configure -- \
		-G Ninja \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=ON

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build/
	rm -f translations/*.qm
	-find manual -name '*.gz' -delete || true

override_dh_auto_build:
	gzip -kf manual/mx-snapshot.8 manual/iso-snapshot-cli.8
	dh_auto_build
	# Copy exclude list for CLI version
	cp -f mx-snapshot-exclude.list iso-snapshot-cli-exclude.list

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_test:
	# Skip tests as no test targets are defined

override_dh_auto_install:
	# Install is handled by debian/install file
	dh_auto_install

%:
	dh $@ --buildsystem=cmake+ninja --no-automatic-dbgsym

## mx-snapshot 25.11

=== debian/changelog ===
mx-snapshot (25.11) mx; urgency=medium

  * Updated config loading to sanitize the persisted cores value.
  * Open grub.cfg and syslinux.cfg in addition to isolinux.cfg when edit_boot_menu = on

 -- Adrian <adrian@mxlinux.org>  Fri, 07 Nov 2025 15:12:20 -0500

## mx-snapshot 25.11.1

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2015-2025 MX Authors
# *
# * Authors: Adrian
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of MX Snapshot.
# *
# * MX Snapshot is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * MX Snapshot is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with MX Tools.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************

cmake_minimum_required(VERSION 3.16)

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

if(NOT DPKG_RESULT EQUAL 0 OR NOT PROJECT_VERSION_FROM_CHANGELOG)
    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
endif()

project(mx-snapshot
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "MX Snapshot - A tool for creating live ISO images from running MX Linux systems"
    LANGUAGES CXX
)

# Set default build type if not specified
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build" FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Options to control what to build
option(BUILD_GUI "Build GUI version" ON)
option(BUILD_CLI "Build CLI version" ON)

# Find Qt6 components - include all components needed for either build
set(QT_COMPONENTS Core LinguistTools)
if(BUILD_GUI)
    list(APPEND QT_COMPONENTS Gui Widgets)
endif()

find_package(Qt6 REQUIRED COMPONENTS ${QT_COMPONENTS})

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Common source files
set(COMMON_SOURCES
    src/log.cpp
    src/main.cpp
    src/cmd.cpp
    src/settings.cpp
    src/batchprocessing.cpp
    src/work.cpp
    src/filesystemutils.cpp
    src/systeminfo.cpp
    src/messagehandler.cpp
)

set(COMMON_HEADERS
    src/common.h
    src/log.h
    src/cmd.h
    src/settings.h
    src/batchprocessing.h
    src/work.h
    src/filesystemutils.h
    src/systeminfo.h
    src/messagehandler.h
)

# GUI-specific source files
set(GUI_SOURCES
    src/mainwindow.cpp
    src/about.cpp
)

set(GUI_HEADERS
    src/mainwindow.h
    src/about.h
)

set(UI_FILES
    src/mainwindow.ui
)

set(RESOURCE_FILES
    images.qrc
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create GUI executable
if(BUILD_GUI)
    add_executable(mx-snapshot
        ${COMMON_SOURCES}
        ${GUI_SOURCES}
        ${COMMON_HEADERS}
        ${GUI_HEADERS}
        ${UI_FILES}
        ${RESOURCE_FILES}
    )

    # Link Qt6 libraries for GUI
    target_link_libraries(mx-snapshot
        Qt6::Core
        Qt6::Gui
        Qt6::Widgets
    )

    set_target_properties(mx-snapshot PROPERTIES
        OUTPUT_NAME "mx-snapshot"
        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endif()

# Create CLI executable
if(BUILD_CLI)
    add_executable(iso-snapshot-cli
        ${COMMON_SOURCES}
        ${COMMON_HEADERS}
        ${RESOURCE_FILES}
    )

    # Set CLI build definition
    target_compile_definitions(iso-snapshot-cli PRIVATE CLI_BUILD=1)

    # Link Qt6 libraries for CLI
    target_link_libraries(iso-snapshot-cli
        Qt6::Core
    )

    set_target_properties(iso-snapshot-cli PROPERTIES
        OUTPUT_NAME "iso-snapshot-cli"
        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endif()

# Function to set common compile options and definitions
function(set_common_properties target)
    # Set compiler flags
    target_compile_options(${target} PRIVATE
        -Wpedantic
        -pedantic
        -Werror=return-type
        -Werror=switch
        -Werror=uninitialized
        -Werror
    )

    # Add compiler-specific flags
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
        target_compile_options(${target} PRIVATE -Werror=return-stack-address)
    else()
        target_compile_options(${target} PRIVATE -Werror=return-local-addr)
    endif()

    # Set compile definitions
    target_compile_definitions(${target} PRIVATE
        QT_DEPRECATED_WARNINGS
        QT_DISABLE_DEPRECATED_BEFORE=0x060000
        VERSION="${PROJECT_VERSION}"
    )

    # Build type specific optimizations
    if(CMAKE_BUILD_TYPE STREQUAL "Release")
        target_compile_definitions(${target} PRIVATE NDEBUG)
        target_compile_options(${target} PRIVATE -O3)

        # Add LTO - different flags for different compilers
        if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
            target_compile_options(${target} PRIVATE -flto=thin)
            target_link_options(${target} PRIVATE -flto=thin)
        else()
            target_compile_options(${target} PRIVATE -flto=auto)
            target_link_options(${target} PRIVATE -flto=auto)
        endif()
    elseif(CMAKE_BUILD_TYPE STREQUAL "Debug")
        target_compile_options(${target} PRIVATE -g -O0)
        target_compile_definitions(${target} PRIVATE DEBUG)
    endif()
endfunction()

# Apply common properties to targets
if(BUILD_GUI)
    set_common_properties(mx-snapshot)
endif()

if(BUILD_CLI)
    set_common_properties(iso-snapshot-cli)
endif()

# Handle translations
if(BUILD_GUI)
    qt6_add_translations(mx-snapshot
        TS_FILES ${TRANSLATION_FILES}
	LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
	QM_FILES_OUTPUT_VARIABLE qm_files
    )
endif()

if(BUILD_CLI)
    qt6_add_translations(iso-snapshot-cli
        TS_FILES ${TRANSLATION_FILES}
	LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
	QM_FILES_OUTPUT_VARIABLE qm_files
    )
endif()



# Installation targets (required by Debian build system)
# Other files are handled by debian/install
if(BUILD_GUI)
    install(TARGETS mx-snapshot
        RUNTIME DESTINATION bin
    )
endif()

if(BUILD_CLI)
    install(TARGETS iso-snapshot-cli
        RUNTIME DESTINATION bin
    )
endif()

=== debian/changelog ===
mx-snapshot (25.11.1) mx; urgency=medium

  * Add f2fs to the list of supported partitions

 -- Adrian <adrian@mxlinux.org>  Mon, 17 Nov 2025 16:36:37 -0500

## mx-snapshot 25.11.2

=== debian/changelog ===
mx-snapshot (25.11.2) mx; urgency=medium

  * Added fallback path for the excludes file in case it's not found
  * Changed allowed filesystems from allowed list to deny list, excluding file
    systems known not to support POSIX permissions, this will allow some more
    obscure Linux filesystem to be used

 -- Adrian <adrian@mxlinux.org>  Wed, 19 Nov 2025 09:37:30 -0500

## mx-snapshot 25.12.2

=== debian/changelog ===
mx-snapshot (25.12.2) mx; urgency=medium

  * Add pop up to show that the maintainer excludes is newer than the
    custom one. Add option for user to show diff, accept changes or
    keep the custom list

 -- Adrian <adrian@mxlinux.org>  Mon, 08 Dec 2025 10:14:38 -0500

mx-snapshot (25.12) mx; urgency=medium

  * Copy the exclusion list to the ~/.config/MX-Linux/ to allow users to
    set their own list that will not be overwritten on updates
  * Improve launching of editor for the exclude list
  * Add custom exclude reset button

 -- Adrian <adrian@mxlinux.org>  Mon, 08 Dec 2025 00:16:10 -0500

## mx-snapshot 25.12.5

=== debian/changelog ===
mx-snapshot (25.12.5) mx; urgency=medium

  * Improve cleanup safety and overlay handling
  * Close app ifthe user doesn't elevate when requested
  * Show debug sizes using 2-decimal MiB format

 -- Adrian <adrian@mxlinux.org>  Sat, 20 Dec 2025 18:22:32 -0500

## mx-snapshot 25.12.6

=== debian/changelog ===
mx-snapshot (25.12.6) mx; urgency=medium

  * Remove exclusion /var/lib/sddm/ which will be handled by live-files
    in mx-remaster

 -- Adrian <adrian@mxlinux.org>  Tue, 23 Dec 2025 21:59:40 -0500

## mx-snapshot 25.12.8

=== debian/changelog ===
mx-snapshot (25.12.8) mx; urgency=medium

  * Fix GUI/CLI space checks: check available space only after selecting
    the snapshot directory in GUI

 -- Adrian <adrian@mxlinux.org>  Sun, 28 Dec 2025 12:45:31 -0500

## mx-snapshot 25.12.9

=== debian/changelog ===
mx-snapshot (25.12.9) mx; urgency=medium

  * Improve calculation of space on root and /home

 -- Adrian <adrian@mxlinux.org>  Wed, 31 Dec 2025 01:02:25 -0500

## mx-snapshot 25.12.12

=== debian/changelog ===
mx-snapshot (25.12.12) mx; urgency=medium

  * Fix exclude size double counting
  * Avoid symlink glob dereference in excludes

 -- Adrian <adrian@mxlinux.org>  Wed, 31 Dec 2025 17:37:38 -0500

## mx-snapshot 26.01

=== debian/changelog ===
mx-snapshot (26.01) mx; urgency=medium

  * CLI/GUI: backup exclusion file on reset
  * Work with more than one location for installed-to-live

 -- Adrian <adrian@mxlinux.org>  Mon, 05 Jan 2026 09:36:43 -0500

## mx-snapshot 26.01.1

=== debian/changelog ===
mx-snapshot (26.01.1) mx; urgency=medium

  * Fix syntax error in cleanup function

 -- Adrian <adrian@mxlinux.org>  Sat, 10 Jan 2026 10:36:43 -0500

## mx-snapshot 26.01.3

=== debian/changelog ===
mx-snapshot (26.01.3) mx; urgency=medium

  * Fix exclude size calc on sparse files

 -- Adrian <adrian@mxlinux.org>  Tue, 13 Jan 2026 19:01:56 -0500

mx-snapshot (26.01.2) mx; urgency=medium

  * GUI: keep boot options after NVIDIA prompt
  * Save log for iso-snapshot-cli too

 -- Adrian <adrian@mxlinux.org>  Sat, 10 Jan 2026 21:59:03 -0500

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Package: mx-snapshot
 Architecture: any
 Depends: mx-iso-template | iso-template (>= 16.1mx15),
-         mx-remaster,
+         mx-remaster (>= 25.12.01),
          mx-viewer | xdg-utils,
          squashfs-tools,
          syslinux-utils,
